#! /usr/bin/perl
$PI=3.14159265358979;
$animation= 0;

$axiswidth= 0.5;
$gridwidth= 0.2;
$ticsize= 4;

# $xmin= -50;
# $xmax= 250;
# $xstep= 50;
# $xlabel= "delta";

# $ymin= -0.025;
# $ymax= 0.025;
# $ystep= 0.005;
# $ylabel= "omega";

# $zmin= 0.2;
# $zmax= 1.2;
# $zstep= 0.2;
# $zlabel= "eq'";

$zmargin= 10;

$zrot= 30;
# chdir "/home/t-kita/mine-home/matx/trs5-data/som";

# @datafile=    ("orbit-TdoD=0.5.dat", "orbit-TdoD=0.5-p10.dat",            "sep-ef116Pm08.dat", "uep-ef116Pm08.dat", "som-TdoD=0.5-1.dat");
# @datacolor=   ("pigment{LimeGreen}", "pigment{color rgb<0.3, 1.0, 0.3>}", "pigment{SkyBlue}",  "pigment{Red}",      "texture{Silver1}");
# @dataplotsize=(0.6,                  0.7,                                 1.5,                 1.5,                 0.6);

# parse gnuplot-like plot file
$dco=0;
while(<>){
    chomp;
    if (/set +view +([0-9.-]+) *, *([0-9.-]+)/){
	$zrot= $2;
    }
    if (/set +([xyz])ra(nge)? +\[ *([0-9.-]+) *: *([0-9.-]+) *\]/){
	if     ($1 eq "x"){
	    $xmin= $3;  $xmax= $4;
	}elsif ($1 eq "y"){
	    $ymin= $3;  $ymax= $4;
	}elsif ($1 eq "z"){
	    $zmin= $3;  $zmax= $4;
	}
    }
    if (/set +([xyz])tic +([0-9.-]+) *, *([0-9.-]+) *, *([0-9.-]+)/){
	if     ($1 eq "x"){
	    $xstep= $3;
	}elsif ($1 eq "y"){
	    $ystep= $3;
	}elsif ($1 eq "z"){
	    $zstep= $3;
	}
    }
    if (/set +([xyz])la(bel)? +"([^"]*)"/){
	if     ($1 eq "x"){
	    $xlabel= $3;
	}elsif ($1 eq "y"){
	    $ylabel= $3;
	}elsif ($1 eq "z"){
	    $zlabel= $3;
	}
    }
    if (/cd +"([^"]*)"/){
	$chdir=$1;
    }
    if (/data\t(.*?)\t(.*?)\t(.*)/){
	$datafile[$dco]= $1;
	$datacolor[$dco]= $2;
	$dataplotsize[$dco++]= $3;
    }
    if (/^# *animation *= *([0-9])/){
	$animation= $1;
    }
#    if (/# *cameraz *= *([0-9.-])/){
#	$cameraz= $1;
#    }
    if ($_ eq "" or $_ =~ /^#/){
	next;
    }
}

## $BL58B%k!<%W$rHr$1$k(B
if ($xstep <= 0.0){ $xstep = 999e99; }
if ($ystep <= 0.0){ $ystep = 999e99; }
if ($zstep <= 0.0){ $zstep = 999e99; }

chdir $chdir;

### for($zrot=0; $zrot<359; $zrot+=10){

$camerax= 500*cos(($zrot-90)/180*$PI) + 25;
$cameray= 500*sin(($zrot-90)/180*$PI) + 25;
# $cameraz= -250-150*(-cos($zrot/360*$PI)+1);
$cameraz= -300;

@camera=(100*cos(($zrot-90)/180*$PI)+25,100*sin(($zrot-90)/180*$PI)+25,$cameraz*0.1);

@kado1=(0,0,0); @kado2=(50,0,0); @kado3=(50,50,0); @kado4=(0,50,0);
$dist= get_minimun_dist(@camera, @kado1, @kado2, @kado3, @kado4);

###print $zrot." ".$dist."\n"; } exit; 


if ($animation==0){
#    $angle= 9.0;
#    print "dist=".$dist;
    $angle= 9.5+0.08*(84.5-$dist);}
else{
    $angle= 9.5;
}

print "#version 3.0\n";
print "#include \"colors.inc\" \n";
print "#include \"shapes.inc\" \n";
print "#include \"textures.inc\" \n";

# $B%+%a%i(B
printf "camera{ location <%g,%g,%g>\n",$camerax,$cameray,$cameraz;
print "sky <0,0,-1>\n";
print "look_at <23,25,-18>\n";
printf "angle %g}\n",$angle;

# $BCOLL$HGX7J(B
print "background{ color White }\n";
print "object{ Plane_XY texture{ PinkAlabaster }}\n";
# $B8w8;(B
printf "light_source{ <%g, %g, %g> color 0.9* White }\n",$camerax,$cameray,$cameraz*1.1;
printf "light_source{ <%g, %g, %g> color 0.9* White }\n",$camerax*0.4,$cameray*0.4,$cameraz*0.7;

#print "light_source{ <25, -25, -100> color 0.4* White }\n";
#print "light_source{ <75, 25, -100> color 0.4* White }\n";
#print "light_source{ <25, 75, -100> color 0.4* White }\n";
#print "light_source{ <-25, 25, -100> color 0.4* White }\n";

# print "light_source{ <20, -50, -100> color 0.3* White }\n";
#print "light_source{ <30, -50, -200> color 0.2* White }\n";
#print "light_source{ <30, 100, -500> color 0.1* White }\n";

print "#declare Samp = union{\n";

# $B<4$H3J;R$HL\@9$N>l9gJ,$1(B
# -------- case 1 -------------
if($animation ==1 or ($zrot%360>=0 and $zrot%360<=90) ){
  print " cylinder{<0,0,0>,<50,0,0>,$axiswidth}\n";
  print " cylinder{<0,50,0>,<50,50,0>,$axiswidth}\n";
  print " cylinder{<0,50,-30-$zmargin>,<50,50,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,0,0>,<0,50,0>,$axiswidth}\n";
  print " cylinder{<50,0,0>,<50,50,0>,$axiswidth}\n";
  print " cylinder{<0,0,-30-$zmargin>,<0,50,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,0,0>,<0,0,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,50,0>,<0,50,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<50,50,0>,<50,50,-30-$zmargin>,$axiswidth}\n";
  for($x=$xmin; $x<$xmax; $x+= $xstep){
    printf " cylinder{<%g,50,0>,<%g,50,-30-$zmargin>,$gridwidth}\n", transX($x),transX($x);}
  for($y=$ymin; $y<$ymax; $y+= $ystep){
    printf " cylinder{<0,%g,0>,<0,%g,-30-$zmargin>,$gridwidth}\n", transY($y),transY($y);}
  for($z=$zmin; $z<$zmax; $z+= $zstep){
    printf "cylinder{<0,0,%g>,<0,50,%g>,$gridwidth}\n",transZ($z),transZ($z);
    printf "cylinder{<0,50,%g>,<50,50,%g>,$gridwidth}\n",transZ($z),transZ($z);}
# x $B<4J}8~$NL\@9(B
for($x=$xmin; $x<$xmax; $x+= $xstep){
    printf " cylinder{<%g,48,-30-$zmargin>,<%g,50,-30-$zmargin>,$axiswidth}\n", transX($x),transX($x);
}
# y $B<4J}8~$NL\@9(B
for($y=$ymin; $y<$ymax; $y+= $ystep){
    printf " cylinder{<0,%g,-30-$zmargin>,<2,%g,-30-$zmargin>,$axiswidth}\n", transY($y),transY($y);
}
# z $B<4J}8~$NL\@9(B
for($z=$zmin; $z<$zmax; $z+= $zstep){
    printf "cylinder{<0,0,%g>,<2,0,%g>,$axiswidth}\n",transZ($z),transZ($z);
}
# z$B<4J}8~$NL\@9$NCM(B
print  " text{ ttf \"crystal.ttf\",\"$zmin\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<-7,-2,2-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$zlabel\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<-8,-2,-15-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$zmax\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<-7,-2,-30-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
}
# -------- case 2 -------------
if($animation==0 and $zrot%360>90 and $zrot%360<=180 ){
  print " cylinder{<0,0,0>,<50,0,0>,$axiswidth}\n";
  print " cylinder{<0,50,0>,<50,50,0>,$axiswidth}\n";
  print " cylinder{<0,0,-30-$zmargin>,<50,0,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,0,0>,<0,50,0>,$axiswidth}\n";
  print " cylinder{<50,0,0>,<50,50,0>,$axiswidth}\n";
  print " cylinder{<0,0,-30-$zmargin>,<0,50,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,0,0>,<0,0,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,50,0>,<0,50,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<50,0,0>,<50,0,-30-$zmargin>,$axiswidth}\n";
  for($x=$xmin; $x<$xmax; $x+= $xstep){
    printf " cylinder{<%g,0,0>,<%g,0,-30-$zmargin>,$gridwidth}\n", transX($x),transX($x);}
  for($y=$ymin; $y<$ymax; $y+= $ystep){
    printf " cylinder{<0,%g,0>,<0,%g,-30-$zmargin>,$gridwidth}\n", transY($y),transY($y);}
  for($z=$zmin; $z<$zmax; $z+= $zstep){
    printf "cylinder{<0,0,%g>,<0,50,%g>,$gridwidth}\n",transZ($z),transZ($z);
    printf "cylinder{<0,0,%g>,<50,0,%g>,$gridwidth}\n",transZ($z),transZ($z);}
# x $B<4J}8~$NL\@9(B
  for($x=$xmin; $x<$xmax; $x+= $xstep){
    printf " cylinder{<%g,0,-30-$zmargin>,<%g,2,-30-$zmargin>,$axiswidth}\n", transX($x),transX($x);
}
# y $B<4J}8~$NL\@9(B
  for($y=$ymin; $y<$ymax; $y+= $ystep){
    printf " cylinder{<0,%g,-30-$zmargin>,<2,%g,-30-$zmargin>,$axiswidth}\n", transY($y),transY($y);
}
# z $B<4J}8~$NL\@9(B
  for($z=$zmin; $z<$zmax; $z+= $zstep){
    printf "cylinder{<0,0,%g>,<2,0,%g>,$axiswidth}\n",transZ($z),transZ($z);
}
# z$B<4J}8~$NL\@9$NCM(B

print  " text{ ttf \"crystal.ttf\",\"$zmin\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<1,51,2-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$zlabel\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<1,51,-15-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$zmax\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<1,51,-30-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
}
# -------- case 3 -------------
if($animation==0 and $zrot%360>180 and $zrot%360<=270 ) {
  print " cylinder{<0,0,0>,<50,0,0>,$axiswidth}\n";
  print " cylinder{<0,50,0>,<50,50,0>,$axiswidth}\n";
  print " cylinder{<0,0,-30-$zmargin>,<50,0,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,0,0>,<0,50,0>,$axiswidth}\n";
  print " cylinder{<50,0,0>,<50,50,0>,$axiswidth}\n";
  print " cylinder{<50,0,-30-$zmargin>,<50,50,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,0,0>,<0,0,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<50,0,0>,<50,0,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<50,50,0>,<50,50,-30-$zmargin>,$axiswidth}\n";
  for($x=$xmin; $x<$xmax; $x+= $xstep){
    printf " cylinder{<%g,0,0>,<%g,0,-30-$zmargin>,$gridwidth}\n", transX($x),transX($x);}
  for($y=$ymin; $y<$ymax; $y+= $ystep){
    printf " cylinder{<50,%g,0>,<50,%g,-30-$zmargin>,$gridwidth}\n", transY($y),transY($y);}
  for($z=$zmin; $z<$zmax; $z+= $zstep){
    printf "cylinder{<50,0,%g>,<50,50,%g>,$gridwidth}\n",transZ($z),transZ($z);
    printf "cylinder{<0,0,%g>,<50,0,%g>,$gridwidth}\n",transZ($z),transZ($z);}
# x $B<4J}8~$NL\@9(B
  for($x=$xmin; $x<$xmax; $x+= $xstep){
    printf " cylinder{<%g,0,-30-$zmargin>,<%g,2,-30-$zmargin>,$axiswidth}\n", transX($x),transX($x);
}
# y $B<4J}8~$NL\@9(B
  for($y=$ymin; $y<$ymax; $y+= $ystep){
    printf " cylinder{<48,%g,-30-$zmargin>,<50,%g,-30-$zmargin>,$axiswidth}\n", transY($y),transY($y);
}
# z $B<4J}8~$NL\@9(B
  for($z=$zmin; $z<$zmax; $z+= $zstep){
    printf "cylinder{<48,0,%g>,<50,0,%g>,$axiswidth}\n",transZ($z),transZ($z);
}
# z$B<4J}8~$NL\@9$NCM(B

print  " text{ ttf \"crystal.ttf\",\"$zmin\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<1,-1,2-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$zlabel\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<1,-1,-15-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$zmax\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<1,-1,-30-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
}
# -------- case 4 -------------
if($animation==0 and $zrot%360>270 and $zrot%360<=360) {
  print " cylinder{<0,0,0>,<50,0,0>,$axiswidth}\n";
  print " cylinder{<0,50,0>,<50,50,0>,$axiswidth}\n";
  print " cylinder{<0,50,-30-$zmargin>,<50,50,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,0,0>,<0,50,0>,$axiswidth}\n";
  print " cylinder{<50,0,0>,<50,50,0>,$axiswidth}\n";
  print " cylinder{<50,0,-30-$zmargin>,<50,50,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<50,0,0>,<50,0,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<0,50,0>,<0,50,-30-$zmargin>,$axiswidth}\n";
  print " cylinder{<50,50,0>,<50,50,-30-$zmargin>,$axiswidth}\n";
  for($x=$xmin; $x<$xmax; $x+= $xstep){
    printf " cylinder{<%g,50,0>,<%g,50,-30-$zmargin>,$gridwidth}\n", transX($x),transX($x);}
  for($y=$ymin; $y<$ymax; $y+= $ystep){
    printf " cylinder{<50,%g,0>,<50,%g,-30-$zmargin>,$gridwidth}\n", transY($y),transY($y);}
  for($z=$zmin; $z<$zmax; $z+= $zstep){
    printf "cylinder{<50,0,%g>,<50,50,%g>,$gridwidth}\n",transZ($z),transZ($z);
    printf "cylinder{<0,50,%g>,<50,50,%g>,$gridwidth}\n",transZ($z),transZ($z);}
# x $B<4J}8~$NL\@9(B
for($x=$xmin; $x<$xmax; $x+= $xstep){
    printf " cylinder{<%g,48,-30-$zmargin>,<%g,50,-30-$zmargin>,$axiswidth}\n", transX($x),transX($x);
}
# y $B<4J}8~$NL\@9(B
for($y=$ymin; $y<$ymax; $y+= $ystep){
    printf " cylinder{<48,%g,-30-$zmargin>,<50,%g,-30-$zmargin>,$axiswidth}\n", transY($y),transY($y);
}
# z $B<4J}8~$NL\@9(B
for($z=$zmin; $z<$zmax; $z+= $zstep){
    printf "cylinder{<48,50,%g>,<50,50,%g>,$axiswidth}\n",transZ($z),transZ($z);
}
# z$B<4J}8~$NL\@9$NCM(B

print  " text{ ttf \"crystal.ttf\",\"$zmin\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<1,51,2-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$zlabel\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<1,51,-15-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$zmax\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<1,51,-30-$zmargin>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
}
# ------------------------------

# x $B<4J}8~$NL\@9(B
for($x=$xmin; $x<$xmax; $x+= $xstep){
    printf " cylinder{<%g,0,0>,<%g,2,0>,$axiswidth}\n",transX($x),transX($x);
    printf " cylinder{<%g,48,0>,<%g,50,0>,$axiswidth}\n",transX($x),transX($x);
}
# y $B<4J}8~$NL\@9(B
for($y=$ymin; $y<$ymax; $y+= $ystep){
    printf " cylinder{<0,%g,0>,<2,%g,0>,$axiswidth}\n",transY($y),transY($y);
    printf " cylinder{<48,%g,0>,<50,%g,0>,$axiswidth}\n",transY($y),transY($y);
}

# x$B<4J}8~$NL\@9$NCM(B
print  " text{ ttf \"crystal.ttf\",\"$xmin\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf  "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<0,-7,-1>\n";
print  "       finish{ambient 3}\n"; 
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$xlabel\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<22,-8,-1>\n";
print  "       finish{ambient 1}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$xmax\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<47,-7,-1>\n";
print  "       finish{ambient 3}\n";
print  "}\n";

# y$B<4J}8~$NL\@9$NCM(B
print  " text{ ttf \"crystal.ttf\",\"$ymin\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<50.5,1,-1>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$ylabel\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<52,25,-1>\n";
print  "       finish{ambient 1}\n";
print  "}\n";
print  " text{ ttf \"crystal.ttf\",\"$ymax\",0.1,0\n";
print  "       pigment{White}\n";
print  "       scale $ticsize\n"; 
printf "       rotate<-60,0,%g+90>\n",($zrot-90);
print  "       translate<51,50,-1>\n";
print  "       finish{ambient 3}\n";
print  "}\n";
print "}\n";
# $B<4$H%0%j%C%I$NI=<((B
print "object{ Samp texture{DMFWood6}}\n";

#  #####
#  open FH, "<orbit-TdoD=7.61.dat";
#  while(<FH>){
#      chomp;
#      if ($_ eq "" or $_ =~ /^#/){ next; }
#  	($x, $y, $z) = split;
#  	printf("object{ Sphere pigment{LimeGreen} scale 0.6 translate <%g,%g,%g>}\n",transX($x),transY($y),transZ($z));
#  }
#  close FH;

#  #####
#  open FH, "<sep-ef116Pm08.dat";
#  while(<FH>){
#      chomp;
#      if ($_ eq "" or $_ =~ /^#/){ next; }
#  	($x, $y, $z) = split;
#  	printf("object{ Sphere pigment{SkyBlue} scale 2.0 translate <%g,%g,%g>}\n",transX($x),transY($y),transZ($z));
#  }
#  close FH;

#  #####
#  open FH, "<uep-ef116Pm08.dat";
#  while(<FH>){
#      chomp;
#      if ($_ eq "" or $_ =~ /^#/){ next; }
#  	($x, $y, $z) = split;
#  	printf("object{ Sphere pigment{Red} scale 2.0 translate <%g,%g,%g>}\n",transX($x),transY($y),transZ($z));
#  }
#  close FH;


#  open FH, "zcat 008.dat.gz|";
#  while(<FH>){
#      chomp;
#      if ($_ eq "" or $_ =~ /^#/){ next; }
#      ($x, $y, $z) = split;
#      printf("object{ Sphere texture{Silver1} scale 0.6 translate <%g,%g,%g>}\n",transX($x),transY($y),transZ($z));
#  }
#  close FH;


for($i=0; $i<=$#datafile; $i++){
    if ($datafile[$i] =~/^</){
	$datafile[$i] =~s/^<//;
	$datafile[$i] = $datafile[$i]."|";
    }else{
	$datafile[$i] = "<".$datafile[$i];
    }
#    printf STDERR "# %s\n", $datafile[$i];
    open FH, $datafile[$i];
    while(<FH>){
	chomp;
	if ($_ eq "" or $_ =~ /^#/){
	    next;
	}
	($x, $y, $z) = split;
	printf("object{ Sphere %s scale %s translate <%g,%g,%g>}\n",$datacolor[$i],$dataplotsize[$i],transX($x),transY($y),transZ($z));
    }
    close FH;
}

# $B%G!<%?$NJQ49$rDj5A$9$k4X?t(B
sub transX{
    local($x)= @_;
    return ($x*-50)/($xmin-$xmax)+($xmin*50)/($xmin-$xmax);
}
sub transY{
    local($y)= @_;
    return ($y*-50)/($ymin-$ymax)+($ymin*50)/($ymin-$ymax);
}
sub transZ{
    local($z)= @_;
    return ($z*30)/($zmin-$zmax)+($zmin*-30)/($zmin-$zmax)-$zmargin;
}

sub get_minimun_dist{
    local(@p)=  @_[0..2];
    local(@p1)= @_[3..5];
    local(@p2)= @_[6..8];
    local(@p3)= @_[9..11];
    local(@p4)= @_[12..14];
    local($d);

    $d=1.0e10;
    if ($d>distance(@p,@p1)){ $d= distance(@p,@p1); }
    if ($d>distance(@p,@p2)){ $d= distance(@p,@p2); }
    if ($d>distance(@p,@p3)){ $d= distance(@p,@p3); }
    if ($d>distance(@p,@p4)){ $d= distance(@p,@p4); }
#    printf("#%g %g %g %g\n",distance(@p,@p1),distance(@p,@p2),distance(@p,@p3),distance(@p,@p4));
#    printf("%s\n%s\n%s\n%s\n",join(",",@p),join(",",@p2),join(",",@p3),join(",",@p4));

    return $d;
}

sub distance{
    local(@x1)= @_[0..2];
    local(@x2)= @_[3..5];

    return sqrt( ($x1[0]-$x2[0])**2 + ($x1[1]-$x2[1])**2 + ($x1[2]-$x2[2])**2 );
}

