#!/usr/bin/perl

$|= 1;  # no buffering
$picdir= "pic";
$datadir= "data";

$picbase= "pic$$";
$pic=      "$picbase.jpg";
$plotfile= "$picbase.gp";
$povfile=  "$picbase.pov";
$wrlfile= "$picbase.wrl";
$tgafile=  "$picbase.tga";

if ($ENV{'REQUEST_METHOD'} eq "POST"){
    read(STDIN, $form_data, $ENV{'CONTENT_LENGTH'});  # receive form data
}else{
    $form_data = $ENV{'QUERY_STRING'};
}

# decode URI encoded data *************************
@part = split('&', $form_data);
foreach $i (@part) {
    ($variable, $value) = split('=', $i);
    $value =~ tr/+/ /;
    $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
    $value =~ s/\r\n/<BR>/g;  $value =~ s/[\r\n]/<BR>/g;
    $value =~ s/<BR>$//g;
    $fdata{$variable}=$value;
}

$datanum = $fdata{'datanum'};  if ($datanum eq ""){ $datanum= 3; }

# default values
$rot_x = $fdata{'rot_x'};  if ($rot_x eq ""){ $rot_x= "60"; }
$rot_z = $fdata{'rot_z'};  if ($rot_z eq ""){ $rot_z= "30"; }

$xlabel = $fdata{'xlabel'};  if ($xlabel eq ""){ $xlabel= "delta"; }
$ylabel = $fdata{'ylabel'};  if ($ylabel eq ""){ $ylabel= "omega"; }
$zlabel = $fdata{'zlabel'};  if ($zlabel eq ""){ $zlabel= "eq'"; }

$xrange = $fdata{'xrange'};  if ($xrange eq ""){ $xrange= "-50:250"; }
$yrange = $fdata{'yrange'};  if ($yrange eq ""){ $yrange= "-0.025:0.025"; }
$zrange = $fdata{'zrange'};  if ($zrange eq ""){ $zrange= "0.2:1.2"; }

$xtic = $fdata{'xtic'};  if ($xtic eq ""){ $xtic= "-50,50,250"; }
$ytic = $fdata{'ytic'};  if ($ytic eq ""){ $ytic= "-0.025,0.005,0.025"; }
$ztic = $fdata{'ztic'};  if ($ztic eq ""){ $ztic= "0.2,0.2,1.2"; }

#$xrange = $fdata{'xrange'};  if ($xrange eq ""){ $xrange= "0:8"; }
#$yrange = $fdata{'yrange'};  if ($yrange eq ""){ $yrange= "-1.5:1.5"; }
#$zrange = $fdata{'zrange'};  if ($zrange eq ""){ $zrange= "-1:1"; }
#
#$xtic = $fdata{'xtic'};  if ($xtic eq ""){ $xtic= "0,1,8"; }
#$ytic = $fdata{'ytic'};  if ($ytic eq ""){ $ytic= "-1.5,0.5,1.5"; }
#$ztic = $fdata{'ztic'};  if ($ztic eq ""){ $ztic= "-1,0.2,1"; }

$quality = $fdata{'quality'};
if     ($quality eq "preview"){
    $q_preview = "checked";
#    $povopt= "+W160 +H120";
    $waitmark="o"x100;
}elsif ($quality eq "320x240"){
    $q_320x240 = "checked";
    $povopt= "+W320 +H240 +A.1";
    $waitmark="o"x20;
}elsif ($quality eq "480x360"){
    $q_480x360 = "checked";
    $povopt= "+W480 +H360 +A.1";
    $waitmark="o"x10;
}elsif ($quality eq "640x480"){
    $q_640x480 = "checked";
    $povopt= "+W640 +H480 +A.1";
    $waitmark="o"x5;
}elsif ($quality eq "1280x960"){
    $q_640x480 = "checked";
    $povopt= "+W1280 +H960 +A.1";
    $waitmark=".";
}else{  # default
    $q_preview = "checked";
#    $povopt= "+W160 +H120";
    $waitmark="o"x20;
}


# default values (valid only for the first time)
if ($fdata{"datafile1"} eq ""){
    $fdata{"datafile1"} = "som-TdoD=0.5-1.dat";
    $fdata{"pointcolor1"} = "texture{Silver1}";
    $fdata{"pointsize1"} = "0.6";

    $fdata{"datafile2"} = "uep-ef116Pm08.dat";
    $fdata{"pointcolor2"} = "pigment{Red}";
    $fdata{"pointsize2"} = "2";

    $fdata{"datafile3"} = "orbit-TdoD=0.5.dat";
    $fdata{"pointcolor3"} = "pigment{LimeGreen}";
    $fdata{"pointsize3"} = "1.2";
}

# ************************************************

$ctime= localtime();
$remotehost = $ENV{'REMOTE_ADDR'};

# make plot file
open(FH, ">$picdir/$plotfile");
print FH <<GPEND;
# $remotehost $ctime
set view $rot_x,$rot_z

set xrange [$xrange]
set yrange [$yrange]
set zrange [$zrange]

set xtic $xtic
set ytic $ytic
set ztic $ztic

set xlabel "$xlabel"
set ylabel "$ylabel"
set zlabel "$zlabel"

cd "$datadir"

GPEND

for($i=1; $i<=$datanum; $i++){
    $datafile= $fdata{"datafile$i"};
    $pointcolor= $fdata{"pointcolor$i"};
    $pointsize= $fdata{"pointsize$i"};

    # avoid filename being specified like "../../../../home/foo/data/...";
    if ($datafile =~ /[.][.]/){
       $datafile= "";  $fdata{"datafile$i"}="";
    }	
    if ($datafile =~ /^http:\/\// or $datafile =~ /^ftp:\/\// ){
	system("cd $datadir; wget $datafile -O - | perl ../limiter.pl > wp$$-$i.dat");
	$datafile = "wp$$-$i.dat";  $fdata{"datafile$i"} = "wp$$-$i.dat";
    }
    unless ($datafile =~ /^ *$/ or $datafile =~ / / or $datafile =~ /\t/){
	printf FH "%s\t./%s\t%s\t%s\n","data",$datafile,$pointcolor,$pointsize;
    }
}
close FH;

# make jpeg file
system("perl gp2pov.pl $picdir/$plotfile > $picdir/$povfile");
#system("cd $picdir; (povray +I$povfile +FC $povopt > /dev/stdout 2>&1) ");
#system("cd $picdir; convert -quality 100 $tgafile $pic");
#system("cd $picdir; rm $povfile $tgafile");


if ($fdata{'VRML'}==1){
  system("perl gp2wrl.pl $picdir/$plotfile > $picdir/$wrlfile");
  print "Content-type: model/vrml\n\n";       #HTTP header
  open FH, "$picdir/$wrlfile"; @tmp=<FH>; print @tmp; close FH;
  exit(0);
}else{
  print "Content-type: text/html\n\n";       #HTTP header
}

# print form page
print <<END1;
<HTML>
<head>
<title>WebPlot3D : 3-dimensional data visualization CGI script</title>
</head>

<body bgcolor="Khaki">

<center>
<font size=4>
    <b>WebPlot3D</b> : 3-dimensional data visualization<br>
    powered by <a href=http://www.povray.org/>POV-Ray</a>.
</font>
</center>
<br>
END1

for($i=1; $i<=$datanum; $i++){
print <<END11;
<script language="JavaScript">
    function setPointColor$i(){
	pos = document.povray1.pointcolor_sel$i.selectedIndex;
	document.povray1.pointcolor$i.value =
	    document.povray1.pointcolor_sel$i.options[pos].value;
    }
</script>
END11
}

$tmp= readpipe "/usr/bin/uptime";
$tmp=~/.*: *([0-9.]+),/;
if ($1>1.1){
    $heavyload= 1;
}

if ($heavyload==1){
    print "<br><font size=6 color=red>\n";
    print "<center><b>\n";
    print "Currently the host has a heavy cpu load.<br>\n";
    print "Please try later.<br>\n";
    print "</b></center>\n";
    print "</font><br><br>\n";
}else{
#    print "<br><font size=2 color=white>";
#    print "o"x125 . "<br>";
    print "<!--"."o"x125 ; #########################3
# make tga file
    if ($pid= fork){
	# Parent
	while(1){
	    print $waitmark;
	    $tmp= readpipe "ps --no-headers -o \"%p\" -C povray";
	    chomp $tmp;
	    if ($tmp eq ""){ last; }
	    sleep 4;
	}
	waitpid($pid,0);
    }else{
	# Child
       	system("cd $picdir; povray +I$povfile +FC $povopt > /dev/null 2>&1");
	exit;
    }
#    print "</font><br><br>";
    print "-->"; #######################
# make jpg file
    system("cd $picdir; convert -quality 100 $tgafile $pic");
    print "\n";
    system("cd $picdir; rm $povfile $tgafile");

    print <<END2;
<center>
<table border=2>
<tr>
<td><img src=$picdir/$pic>
</tr>
</table>
</center>
<br>
END2
}

print <<END3;  
<FORM name="povray1" METHOD="get" ACTION="./plot.cgi">      
<center>
<table noborder width=60%>
<tr><td nowrap align=right>
<INPUT TYPE="submit" VALUE="replot"> &nbsp; &nbsp;
<font size=-1>number of datafiles:</font>
<select name="datanum" onChange="Javascript:document.povray1.submit()">
END3
    for($i=1; $i<=10; $i++){
	if ($i == $datanum){
	    printf "<option value=\"%d\" selected>%d\n",$i,$i;
	}else{
	    printf "<option value=\"%d\">%d\n",$i,$i;
	}
    }

print <<END30;
</select>
</td></tr></table>
</center>

<center>
<table noborder>
<tr>
<td align=center>DataFile</td>
<td align=center colspan="2">PointColor</td>
<td align=center>PointSize</td>
</tr>
END30

for($i=1; $i<=$datanum; $i++){
$datafile= $fdata{"datafile$i"};
$pointcolor= $fdata{"pointcolor$i"};
$pointsize= $fdata{"pointsize$i"};
print <<END31;
<tr>
<td><input type="text" name="datafile$i" size="34" maxlength="256" value="$datafile"></td>
<td><select name="pointcolor_sel$i" onChange="setPointColor$i()">
<option value="pigment{Red}">-select-
<option value="pigment{Red}">red
<option value="pigment{Green}">green
<option value="pigment{Blue}">blue
<option value="pigment{Magenta}">magenta
<option value="pigment{Cyan}">cyan
<option value="pigment{Brown}">brown
<option value="pigment{Yellow}">yellow
<option value="pigment{Orange}">orange
<option value="pigment{White}">white
<option value="pigment{Gray}">gray
<option value="pigment{Black}">black
<option value="pigment{NeonPink}">pink
<option value="pigment{SkyBlue}">skyblue
<option value="pigment{Aquamarine}">aquamarine
<option value="pigment{LimeGreen}">limegreen
<option value="texture{Silver1}">silver
<option value="texture{DMFWood1}">wood
<option value="texture{Orange_Glass}">glass
<option value="texture{Gold_Metal}">gold_metal
<option value="texture{Aluminum}">aluminum
</select></td>
<td><input type="text" name="pointcolor$i" size="18" maxlength="128" value="$pointcolor"></td>
<td><input type="text" name="pointsize$i" size="10" maxlength="10" value="$pointsize"></td>
</tr>
END31
}
print "</table>\n";
print "<br>\n";

print <<ENDA;
<table border>
<tr>
  <td> </td>
  <td align=center>label</td>
  <td align=center>range</td>
  <td align=center>tic</td>
</tr>
<tr>
  <td>x-axis</td>
  <td><input type="text" name="xlabel" size="15" maxlength="128" value="$xlabel"></td>
  <td><input type="text" name="xrange" size="20" maxlength="128" value="$xrange"></td>
  <td><input type="text" name="xtic"   size="25" maxlength="128" value="$xtic"></td>
</tr>
<tr>
  <td>y-axis</td>
  <td><input type="text" name="ylabel" size="15" maxlength="128" value="$ylabel"></td>
  <td><input type="text" name="yrange" size="20" maxlength="128" value="$yrange"></td>
  <td><input type="text" name="ytic"   size="25" maxlength="128" value="$ytic"></td>
</tr>
<tr>
  <td>z-axis</td>
  <td><input type="text" name="zlabel" size="15" maxlength="128" value="$zlabel"></td>
  <td><input type="text" name="zrange" size="20" maxlength="128" value="$zrange"></td>
  <td><input type="text" name="ztic"   size="25" maxlength="128" value="$ztic"></td>
</tr>
</table>
<br>
ENDA

########## rot_x 
print '<tr> <td>rot_x : </td> <td><select name="rot_x">'."\n";
#for($r=0; $r<=350; $r+=10){
for($r=60; $r<=60; $r+=10){
    if ($r == $rot_x){
	printf("<option value=\"$r\" selected>$r\n");
    }else{
	printf("<option value=\"$r\">$r\n");
    }
}
print "</td> </select>\n";

########## rot_z
print '<td> &nbsp; &nbsp; rot_z : </td> <td><select name="rot_z">'."\n";
for($r=0; $r<=350; $r+=10){
    if ($r == $rot_z){
	printf("<option value=\"$r\" selected>$r\n");
    }else{
	printf("<option value=\"$r\">$r\n");
    }
}
print "</td> </select>\n";



print <<END4
<br>
</table>
<table>
<tr>
<td>
<input type="radio" name="quality" value="preview" $q_preview> preview
<input type="radio" name="quality" value="320x240" $q_320x240> 320 x 240
<input type="radio" name="quality" value="480x360" $q_480x360> 480 x 360
<input type="radio" name="quality" value="640x480" $q_640x480> 640 x 480
</td>
</tr>
</table>

<table>
<tr>
<td>
<input type="checkbox" name="VRML" value="1"> VRML
</td>
</tr>
</table>


</center>

</FORM>

</BODY>
</HTML>
END4
